' add a COM reference for:
' Microsoft ADO Ext. for DDL and Security (ADOX)
Imports System.IO
Imports System.Data.OleDb

'
' A simple class for dealing with Microsoft Access databases
'
Public Class Database
    Private da As New OleDbDataAdapter
    Private con As New OleDbConnection

    '
    ' create a new empty Microsoft Access MDB file
    '
    Public Sub CreateDatabase(ByVal mdb_name As String)
        Dim cat As New ADOX.Catalog

        ' if it already exits, then that's OK by me
        If File.Exists(mdb_name) Then
            Exit Sub
        End If

        cat.Create("Provider='Microsoft.Jet.OLEDB.4.0';Data Source='" & mdb_name & "'")
    End Sub

    '
    ' create a new table (if it doesn't already exist)
    '
    Public Sub CreateTable(ByVal mdb_name As String, ByVal table_name As String, ByVal DDL As String)
        Dim cmd As New OleDbCommand
        Dim dt As DataTable
        Dim dr As DataRow

        If con.State <> ConnectionState.Open Then
            con.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & mdb_name
            con.Open()
        End If

        dt = con.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, New Object() {Nothing, Nothing, Nothing, "TABLE"})
        For Each dr In dt.Rows
            If table_name.ToLower = dr("TABLE_NAME").ToString.ToLower Then
                ' if it already exists, then that's OK by me
                Exit Sub
            End If
        Next

        ' build the new table 
        cmd.CommandText = "Create Table [" & table_name & "]" & DDL
        cmd.Connection = con
        cmd.ExecuteNonQuery()
    End Sub

    '
    ' Open and return a DataTable
    '
    Function OpenTable(ByVal db_path As String, ByVal db_table As String) As DataTable
        Dim cmd As New OleDbCommand
        Dim dt As New DataTable

        If con.State <> ConnectionState.Open Then
            con.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & db_path
            con.Open()
        End If

        cmd.Connection = con
        cmd.CommandText = "Select * from [" & db_table & "]"
        da.SelectCommand = cmd
        da.Fill(dt)

        dt.ExtendedProperties("CommandText") = cmd.CommandText
        Return dt
    End Function

    '
    ' Update the data in the underlying database
    '
    Sub UpdateTable(ByVal dt As DataTable)
        Dim cb As OleDbCommandBuilder

        da.SelectCommand.CommandText = dt.ExtendedProperties("CommandText").ToString
        cb = New OleDbCommandBuilder(da)
        da.Update(dt)
    End Sub

    '
    ' Close the connection
    '
    Sub Close()
        If con.State <> ConnectionState.Closed Then
            con.Close()
        End If
    End Sub
End Class

